<?xml version="1.0" encoding="UTF-8"?>
<beans xmlns="http://www.springframework.org/schema/beans"
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns:tx="http://www.springframework.org/schema/tx"
       xmlns:aop="http://www.springframework.org/schema/aop"
       xmlns:context="http://www.springframework.org/schema/context"
       xmlns:p="http://www.springframework.org/schema/p"
       xsi:schemaLocation="
       http://www.springframework.org/schema/beans
       http://www.springframework.org/schema/beans/spring-beans.xsd
       http://www.springframework.org/schema/tx
       http://www.springframework.org/schema/tx/spring-tx-3.0.xsd
       http://www.springframework.org/schema/context
       http://www.springframework.org/schema/context/spring-context-3.0.xsd
       http://www.springframework.org/schema/aop
       http://www.springframework.org/schema/aop/spring-aop-3.0.xsd">

    <!-- service.impl包下所有标注@Service的服务组件 -->
    <context:component-scan base-package="site.clzblog.msshj.service.impl"/>

    <bean id="txManager" class="org.springframework.orm.hibernate4.HibernateTransactionManager" p:sessionFactory-ref="sessionFactory"/>

    <!--使用强大的切点表达式语言轻松定义目标方法-->
    <aop:config proxy-target-class="true">
        <!--通过aop定义事务增强切面-->
        <aop:pointcut id="serviceMethod" expression="execution(* site.clzblog.msshj.service.impl.*Service.*(..))"/>
        <!--引用事务增强-->
        <aop:advisor pointcut-ref="serviceMethod" advice-ref="txAdvice"/>
    </aop:config>

    <!--事务增强-->
    <tx:advice id="txAdvice" transaction-manager="txManager">
        <!--事务属性定义-->
        <tx:attributes>
            <tx:method name="*"/>
        </tx:attributes>
    </tx:advice>

    <tx:annotation-driven transaction-manager="txManager"/>

    <!-- 数据访问层配置 -->
    <import resource="ip-dao.xml"/>
</beans>